<template>
  <div class="activity-page h-100">
    <left-form-wrapper
      title="Смена пароля"
      background="1"
    >
      <transition
        name="fadeIn"
        @after-leave="afterLeaveForm"
      >
        <ObForm
          v-if="showForm"
          ref="obForm"
          :form-data="formData"
          ok-text="Сменить пароль"
          :is-only-submit="true"
          :is-submit-disabled="!isStateValid"
          :is-on-press-enter-submit="true"
          @submit="sendFormData"
        >
          <div class="description">
            <p>Придумайте новый пароль. <br>Постарайтесь не забывать его.</p>
          </div>
          <ObInput
            v-model="formData.password"
            class="mb20"
            label="Новый пароль"
            type="password"
            :is-valid="getState('password')"
            :validation-message="getValidationMessage('password')"
            :disabled="!isReady"
            placeholder="Придумайте надёжный пароль"
            @blur="onBlurInput('password')"
          />
          <ObInput
            v-model="formData.repeatPassword"
            label="Новый пароль"
            type="password"
            :is-valid="getState('repeatPassword')"
            :validation-message="getValidationMessage('repeatPassword')"
            placeholder="Введите пароль повторно"
            :disabled="!isReady"
            @blur="onBlurInput('repeatPassword')"
          />
        </ObForm>
      </transition>
      <transition name="fadeIn">
        <div v-if="sended">
          <p class="description">
            Пароль был успешно изменен.
          </p>
          <ObButton
            class="w-100"
            label="На страницу входа"
            :to="{ name: 'login' }"
          />
        </div>
      </transition>
    </left-form-wrapper>
  </div>
</template>

<script>
import LeftFormWrapper from '../../components/LeftFormWrapper/index'
import ObForm from 'common-components/src/obComponents/obForm'
import ObButton from 'common-components/src/obComponents/obButton'
import ObInput from 'common-components/src/obComponents/obInput'
import routeMixin from '../../mixins/route-mixin'
import api from '@/api'

export default {
  name: 'ChangePassword',
  components: {
    ObForm,
    LeftFormWrapper,
    ObButton,
    ObInput
  },
  mixins: [
    routeMixin
  ],
  data () {
    return {
      formData: {
        password: '',
        repeatPassword: ''
      },
      showForm: true,
      sended: false,
      dirty: {
        password: false,
        repeatPassword: false
      },
      stateValid: false,
      isReady: false,
      error: null
    }
  },
  computed: {
    isStateValid () {
      return this.stateValid || (this.isAllDirty && this.passwordsEqual && this.passwordsValid)
    },
    isAllDirty () {
      return !Object.values(this.dirty).includes(false)
    },
    passwordsEqual () {
      return this.formData.password && this.formData.repeatPassword && this.formData.password === this.formData.repeatPassword
    },
    passwordsValid () {
      return this.formData.password.length > 5 && this.formData.repeatPassword.length > 5
    },
    restoreId () {
      return this.$route && this.$route.params.id
    }
  },
  watch: {
    formData: {
      deep: true,
      handler () {
        this.stateValid = this.passwordsEqual && this.passwordsValid
        if (this.error) {
          this.error = null
        }
      }
    },
    isStateValid (val) {
      if (val) {
        this.$refs.obForm && this.$refs.obForm.$el.querySelector('.form-footer button').focus()
      }
    }
  },
  mounted () {
    this.checkUuid()
  },
  methods: {
    async sendFormData () {
      this.error = null
      let res = await api.registration.auth.saveNewPassword({ password: this.formData.password, uuid: this.restoreId })

      if (res && res.error) {
        this.error = 'Не удалось сохранить новый пароль, попробуйте позднее'
      } else {
        this.showForm = false
      }
    },
    onBlurInput (key) {
      if (this.formData[key]) {
        this.dirty[key] = true
      }
    },
    getState (key) {
      if (this.formData[key] && this.formData[key].length < 6) {
        return false
      } else if (this.isAllDirty) {
        return this.passwordsEqual
      }

      return this.isStateValid || null
    },
    getValidationMessage (key) {
      if (this.formData[key] && this.formData[key].length < 6) {
        return 'Пароль должен содержать не менее 6 символов'
      } else if (this.isAllDirty) {
        return this.passwordsEqual ? '' : 'Введенные пароли должны совпадать'
      }

      return ''
    },
    afterLeaveForm () {
      this.sended = true
    },
    async checkUuid () {
      let res = await api.registration.auth.startRestorePassword({ uuid: this.restoreId })
      if (res && res.error) {
        this.$router.replace({ name: 'entry' })
      } else {
        this.isReady = true
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.description {
  @include font-mixin(16px, 24px, 700, inherit, 0.4px);
  margin-bottom: 20px;

  p {
    margin-bottom: 12px;
  }
}
</style>
